<?php

/**
 * @file
 * Post-update functions for Limited field widget.
 */

use Drupal\Core\Config\Entity\ConfigEntityUpdater;
use Drupal\Core\Entity\Display\EntityFormDisplayInterface;

/**
 * Fix existing schema issues.
 */
function limited_field_widgets_post_update_fix_schema(&$sandbox = []) {
  $config_entity_updater = \Drupal::classResolver(ConfigEntityUpdater::class);
  $config_entity_updater->update($sandbox, 'entity_form_display', function (EntityFormDisplayInterface $form_display): bool {
    $changed = FALSE;

    foreach ($form_display->getComponents() as $field => $component) {
      if (isset($component['third_party_settings']['limited_field_widgets']) && array_key_exists('limit_values', $component['third_party_settings']['limited_field_widgets'])
      ) {
        // Resave existing file casting to int.
        $component['third_party_settings']['limited_field_widgets']['limit_values'] = (int) $component['third_party_settings']['limited_field_widgets']['limit_values'];
        $form_display->setComponent($field, $component);
        $changed = TRUE;
      }
    }
    return $changed;
  });
}
