<?php

namespace Drupal\limited_field_widgets\Plugin\Validation\Constraint;

use Drupal\Core\StringTranslation\TranslatableMarkup;
use Symfony\Component\Validator\Constraint;

/**
 * Validation constraint for checking maximum item count.
 */
#[\Drupal\Core\Validation\Attribute\Constraint(
  id: 'ItemCount',
  label: new TranslatableMarkup('Maximum item count', [], ['context' => 'Validation']),
  type: 'string'
)]
class ItemCountConstraint extends Constraint {

  /**
   * The error message.
   *
   * @var string
   */
  public string $tooManyItems = 'Field contains too many values, up to %max allowed.';


  /**
   * The max value.
   *
   * @var int
   */
  public int $max;

}
