<?php

namespace Drupal\limited_field_widgets\Plugin\Validation\Constraint;

use Symfony\Component\Validator\Constraint;
use Symfony\Component\Validator\ConstraintValidator;

/**
 * Checks that item count doesn't go past the max.
 */
class ItemCountConstraintValidator extends ConstraintValidator {

  /**
   * {@inheritdoc}
   */
  public function validate($value, Constraint $constraint): void {
    if ($constraint->max === 0) {
      return;
    }

    if (count($value) > $constraint->max) {
      $this->context->addViolation($constraint->tooManyItems, ['%max' => $constraint->max]);
    }
  }

}
